package io.p2vman.pilers;

import cloud.commandframework.CommandManager;
import cloud.commandframework.execution.CommandExecutionCoordinator;
import cloud.commandframework.paper.PaperCommandManager;

import io.p2vman.pilers.events.Event;
import io.p2vman.pilers.events.TestEvent;
import it.unimi.dsi.fastutil.Pair;
import lombok.AllArgsConstructor;
import lombok.Getter;

import net.kyori.adventure.text.Component;
import net.kyori.adventure.title.TitlePart;

import org.bukkit.*;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.EventPriority;
import org.bukkit.event.Listener;
import org.bukkit.event.entity.PlayerDeathEvent;
import org.bukkit.event.player.PlayerJoinEvent;
import org.bukkit.event.player.PlayerQuitEvent;
import org.bukkit.inventory.ItemStack;
import org.bukkit.plugin.java.JavaPlugin;

import java.util.*;
import java.util.concurrent.CompletableFuture;
import java.util.function.Function;
import java.util.logging.Logger;
import java.util.stream.Stream;

public final class Pilers extends JavaPlugin implements Listener {
    public static final Logger LOGGER = Logger.getLogger("Fucked");

    @AllArgsConstructor
    @Getter
    public static class GameState {
        ItemRandom random;
        Builder builder;
        String id;
        boolean start;
        RandomConfig rc;
        @AllArgsConstructor
        @Getter
        public static class RandomConfig {
            int second_toitem;
            int min_items;
            int max_items;
        }
        List<Event> events;
        Event curent;
    }

    @EventHandler(priority = EventPriority.MONITOR)
    public void onPlayerJoin(PlayerJoinEvent event) {
        Player player = event.getPlayer();
        if (state != null && state.start) {
            boolean f = false;
            for (String str : player.getScoreboardTags()) {
                if (Objects.equals(str, "p_"+state.id)) {
                    f = true;
                    break;
                }
            }
            if (!f) {
                player.setGameMode(GameMode.SPECTATOR);
                Iterator<String> tags = player.getScoreboardTags().iterator();
                while (tags.hasNext()) player.removeScoreboardTag(tags.next());
            }
        }
        else {
            player.setGameMode(GameMode.SURVIVAL);
            Iterator<String> tags = player.getScoreboardTags().iterator();
            while (tags.hasNext()) player.removeScoreboardTag(tags.next());
            player.teleport(new Location(Bukkit.getWorlds().get(0), 0, 0, 0));
            Bukkit.getWorlds().get(0).setType(0,-1,0, Material.STONE);
        }
    }

    @EventHandler(priority = EventPriority.MONITOR)
    public void onPlayerQuit(PlayerQuitEvent event) {
        update();
    }

    @EventHandler(priority = EventPriority.MONITOR)
    public void onPlayerDeath(PlayerDeathEvent event) {
        Iterator<String> tags = event.getPlayer().getScoreboardTags().iterator();
        while (tags.hasNext()) event.getPlayer().removeScoreboardTag(tags.next());
        event.getPlayer().setGameMode(GameMode.SPECTATOR);
        update();
    }

    public void update() {
        LOGGER.info("update");
        if (state == null || !state.start) {
            LOGGER.info("call");
            return;
        }
        Collection<? extends Player> players = Bukkit.getOnlinePlayers();
        int online = players.size();
        if (online <= 1) {
            stop(Optional.empty());
            LOGGER.info("b");
        }
        else {
            int c = 0;
            Player f = null;
            for (Player player : players) {
                if (player.getGameMode() == GameMode.SURVIVAL && player.getScoreboardTags().contains("p_" + state.id)) {
                    c++;
                    f = player;
                }
            }
            if (c <= 1) {
                LOGGER.info("a");
                stop(Optional.ofNullable(f));
            }
        }
    }

    GameState state = null;

    public void stop(Optional<Player> win) {
        LOGGER.info("stop");
        taskMannager.cancel("item", "event", "border");
        state.start = false;
        Collection<? extends Player> players = Bukkit.getOnlinePlayers();
        Bukkit.getWorlds().get(0).setType(0,-1,0, Material.STONE);
        Location location = new Location(Bukkit.getWorlds().get(0), 0, 0, 0);
        for (Player player : players) {
            player.setGameMode(GameMode.SURVIVAL);
            Iterator<String> tags = player.getScoreboardTags().iterator();
            while (tags.hasNext()) player.removeScoreboardTag(tags.next());
            player.teleport(location);
            win.ifPresentOrElse((w) -> {
                player.sendTitlePart(TitlePart.TITLE, Component.text("Player ").append(w.displayName()).append(Component.text(" win")));
            }, () -> {
                player.sendTitlePart(TitlePart.TITLE, Component.text("No win"));
            });
        }

        win.ifPresentOrElse((w) -> {

        }, () -> {

        });
        state = null;
    }

    public TaskMannager taskMannager;

    @Override
    public void onEnable() {
        taskMannager = new TaskMannager(getServer().getScheduler(), this);
        getServer().getPluginManager().registerEvents(this, this);
        try {
            CommandManager<CommandSender> manager = new PaperCommandManager<>(this, CommandExecutionCoordinator.simpleCoordinator(), Function.identity(), Function.identity());

            manager.command(manager.commandBuilder("test")
                    .handler((ctx) -> {
                        Builder builder = new Builder();
                        ItemRandom random = new ItemRandom();
                        Server server = getServer();
                        World world = Bukkit.getWorlds().get(0);
                        taskMannager.cancel("item", "event", "border");


                        byte[] buff = new byte[12];
                        random.nextBytes(buff);

                        Collection<? extends Player> players = Bukkit.getOnlinePlayers();
                        state = new GameState(random, builder, Base64.getEncoder().encodeToString(buff), false, new GameState.RandomConfig(10, 2, 4), new ArrayList<>(), null);
                        state.events.add(new TestEvent());

                        builder.build(players.size(), (p) -> {
                            ctx.getSender().sendMessage("End");
                            List<Player> players_ = new ArrayList<>(Bukkit.getOnlinePlayers());

                            players_.forEach((e) -> {
                                Iterator<String> tags = e.getScoreboardTags().iterator();
                                while (tags.hasNext()) e.removeScoreboardTag(tags.next());
                                e.addScoreboardTag("p_"+state.id);
                                e.setGameMode(GameMode.SURVIVAL);
                            });

                            Iterator<? extends Player> it = players_.iterator();
                            p.forEach((a) -> {
                                int x = (int) (a >> 32);
                                int z = (int) (a & 0xFFFFFFFFL);
                                int y = world.getHighestBlockAt(x, z).getY()+1;
                                if (it.hasNext()) {
                                    it.next().teleport(new Location(world, x, y, z).add(0.5, 0, 0.5));
                                }
                            });

                            state.start = true;

                            taskMannager.runRepeating("item", () -> {
                                Collection<? extends Player> _players = Bukkit.getOnlinePlayers();
                                Stream<ItemStack> stackStream = random.itemStackStream(0, 0, ItemRandom.ITEM);

                                _players.forEach((p_) -> {
                                    if (p_.getGameMode() == GameMode.SURVIVAL) {
                                        stackStream
                                                .limit(random.nextInt(state.rc.min_items, state.rc.max_items))
                                                .forEach(p_.getInventory()::addItem);
                                    }
                                });
                            }, 0, 20L * state.rc.second_toitem);

                            taskMannager.runRepeating("event", () -> {
                                taskMannager.cancel("event_run");
                                state.curent = state.events.get(random.nextInt(state.events.size()));
                                LOGGER.info("Event start");
                                taskMannager.runAsync("event_run", state.curent)
                                        .thenRun(() -> {
                                            LOGGER.info("Event end");
                                        });
                            }, 20L * 60, 20L * 60);

                            taskMannager.runRepeating("border", () -> {

                            }, 20L * 60, 20L * 10);
                        }, (c) -> {
                            ctx.getSender().sendMessage(c);
                        });
                    }));
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    @Override
    public void onDisable() {
        // Plugin shutdown logic
    }
}
